/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.18 Revision 1.46
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.18 2009/05/09 13:23:15 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.46 2010/12/29 17:06:51 tampakrap Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
14 14
15inherit kde4-base versionator 15inherit kde4-base versionator
16 16
17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
18 18
19if [[ -z ${KMNAME} ]]; then
20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild" 19[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
21fi
22
23case ${KDEBASE} in
24 kde-base)
25 HOMEPAGE="http://www.kde.org/"
26 LICENSE="GPL-2"
27 ;;
28 koffice)
29 HOMEPAGE="http://www.koffice.org/"
30 LICENSE="GPL-2"
31 ;;
32esac
33
34# Add khelpcenter dependency when installing
35if [[ ${PN} != khelpcenter ]] && has doc ${IUSE//+} && use doc; then
36 RDEPEND="${RDEPEND}
37 >=kde-base/khelpcenter-${PV}:${SLOT}[kdeprefix=]
38 "
39fi
40 20
41# Add dependencies that all packages in a certain module share. 21# Add dependencies that all packages in a certain module share.
42case ${KMNAME} in 22case ${KMNAME} in
43 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphic) 23 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics)
44 DEPEND="${DEPEND} 24 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
45 >=kde-base/qimageblitz-0.0.4
46 "
47 RDEPEND="${RDEPEND}
48 >=kde-base/qimageblitz-0.0.4
49 "
50 ;; 25 ;;
51 kdenetwork) 26 kdepim|kdepim-runtime)
52 DEPEND="${DEPEND}
53 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
54 "
55 RDEPEND="${RDEPEND}
56 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
57 "
58 ;;
59 kdepim)
60 DEPEND="${DEPEND}
61 dev-libs/boost
62 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
63 "
64 RDEPEND="${RDEPEND}
65 dev-libs/boost
66 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
67 "
68 case ${PN} in 27 case ${PN} in
69 akregator|kaddressbook|kjots|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 28 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
70 IUSE="+kontact" 29 IUSE+=" +kontact"
71 RDEPEND="${RDEPEND} 30 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
72 kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )
73 "
74 ;; 31 ;;
75 esac 32 esac
76 ;; 33 ;;
77 kdegames) 34 kdegames)
78 if [[ ${PN} != libkdegames ]]; then 35 if [[ ${PN} != libkdegames ]]; then
79 DEPEND="${DEPEND} 36 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
80 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
81 "
82 RDEPEND="${RDEPEND}
83 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
84 "
85 fi 37 fi
86 ;; 38 ;;
87 koffice) 39 koffice)
88 [[ ${PN} != koffice-data ]] && IUSE="debug" 40 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
89 RDEPEND="${RDEPEND} 41 RDEPEND+="
90 !kdeprefix? (
91 !app-office/${PN}:0 42 !app-office/${PN}:0
92 !app-office/koffice:0 43 !app-office/koffice:0
93 !app-office/koffice-meta:0 44 !app-office/koffice-meta:0
94 )
95 " 45 "
46 if has openexr ${IUSE//+}; then
47 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
48 else
49 COMMONDEPEND+=" media-gfx/imagemagick"
50 fi
51
96 COMMON_DEPEND=" 52 COMMONDEPEND+="
97 dev-cpp/eigen:2 53 dev-cpp/eigen:2
98 media-gfx/imagemagick[openexr?]
99 media-libs/fontconfig 54 media-libs/fontconfig
100 media-libs/freetype:2 55 media-libs/freetype:2
101 " 56 "
102 DEPEND="${DEPEND} ${COMMON_DEPEND}"
103 RDEPEND="${RDEPEND} ${COMMON_DEPEND}"
104 unset COMMON_DEPEND
105 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then 57 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
106 DEPEND="${DEPEND}
107 >=app-office/koffice-libs-${PV}:${SLOT} 58 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
108 "
109 RDEPEND="${RDEPEND}
110 >=app-office/koffice-libs-${PV}:${SLOT}
111 "
112 fi 59 fi
113 ;; 60 ;;
114esac 61esac
62
63DEPEND+=" ${COMMONDEPEND}"
64RDEPEND+=" ${COMMONDEPEND}"
65unset COMMONDEPEND
115 66
116debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 67debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
117debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 68debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
118 69
119# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc) 70# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
147# If set to "true", $KMMODULE doesn't have to be defined. 98# If set to "true", $KMMODULE doesn't have to be defined.
148# 99#
149# Example usage: If you're installing subdirectories of a package, like plugins, 100# Example usage: If you're installing subdirectories of a package, like plugins,
150# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and 101# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
151# set KMNOMODULE="true". 102# set KMNOMODULE="true".
152if [[ -z ${KMMODULE} && ${KMNOMODULE} != true ]]; then 103if [[ -z ${KMMODULE} ]] && [[ ${KMNOMODULE} != true ]]; then
153 KMMODULE=${PN} 104 KMMODULE=${PN}
154fi 105fi
155 106
156# @ECLASS-VARIABLE: KMEXTRA 107# @ECLASS-VARIABLE: KMEXTRA
157# @DESCRIPTION: 108# @DESCRIPTION:
158# All subdirectories listed here will be extracted, compiled & installed. 109# All subdirectories listed here will be extracted, compiled & installed.
159# $KMMODULE is always added to $KMEXTRA. 110# $KMMODULE is always added to $KMEXTRA.
160# If the htmlhandbook USE-flag is set, and if this directory exists, 111# If KDE_HANDBOOK is 'always' or 'optional' and handbook USE-flag is set, and if this
161# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 112# directory exists, then "doc/$KMMODULE" is added to $KMEXTRA. If there's additional
162# handled in the ebuild.
163# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 113# documentation in different subdirectories, it should be added to KMEXTRA manually..
164 114
165# @ECLASS-VARIABLE: KMCOMPILEONLY 115# @ECLASS-VARIABLE: KMCOMPILEONLY
166# @DESCRIPTION: 116# @DESCRIPTION:
167# All subdirectories listed here will be extracted & compiled, but not installed. 117# All subdirectories listed here will be extracted & compiled, but not installed.
168 118
250 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 200 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
251 fi 201 fi
252 else 202 else
253 local abort tarball tarfile f extractlist moduleprefix postfix 203 local abort tarball tarfile f extractlist moduleprefix postfix
254 case ${PV} in 204 case ${PV} in
255 4.2.85) 205 4.[45].8[05] | 4.[45].9[023568])
256 # block for normally packed upstream unstable snapshots 206 # Block for normally packed upstream unstable snapshots
257 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2 207 KMTARPARAMS+=" --bzip2" # bz2
258 postfix="bz2" 208 postfix="bz2"
259 ;; 209 ;;
260 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*)
261 KMTARPARAMS="${KMTARPARAMS} --lzma" # lzma
262 postfix="lzma"
263 ;;
264 *) 210 *)
265 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2 211 KMTARPARAMS+=" --bzip2" # bz2
266 postfix="bz2" 212 postfix="bz2"
267 ;; 213 ;;
268 esac 214 esac
269 case ${KMNAME} in 215 case ${KMNAME} in
270 kdebase-apps) 216 kdebase-apps)
271 # kdebase/apps -> kdebasa-apps 217 # kdebase/apps -> kdebase-apps
272 tarball="kdebase-${PV}.tar.${postfix}" 218 tarball="kdebase-${PV}.tar.${postfix}"
273 # Go one level deeper for kdebase-apps in tarballs 219 # Go one level deeper for kdebase-apps in tarballs
274 moduleprefix=apps/ 220 moduleprefix=apps/
275 KMTARPARAMS="${KMTARPARAMS} --transform=s|apps/||" 221 KMTARPARAMS+=" --transform=s|apps/||"
222 ;;
223 kdepim)
224 if [[ ${PV} == 4.5.93 ]] ; then
225 tarball="kdepim-4.6beta3.tar.${postfix}"
226 fi
276 ;; 227 ;;
277 *) 228 *)
278 # Create tarball name from module name (this is the default) 229 # Create tarball name from module name (this is the default)
279 tarball="${KMNAME}-${PV}.tar.${postfix}" 230 tarball="${KMNAME}-${PV}.tar.${postfix}"
280 ;; 231 ;;
281 esac 232 esac
282 233
283 # Full patch to source tarball 234 # Full path to source tarball
284 tarfile="${DISTDIR}/${tarball}" 235 tarfile="${DISTDIR}/${tarball}"
285 236
286 # Detect real toplevel dir from tarball name - it will be used upon extraction 237 # Detect real toplevel dir from tarball name - it will be used upon extraction
287 # and in __list_needed_subdirectories 238 # and in __list_needed_subdirectories
288 topdir="${tarball%.tar.*}/" 239 topdir="${tarball%.tar.*}/"
292 kde4-meta_create_extractlists 243 kde4-meta_create_extractlists
293 244
294 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 245 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \
295 AUTHORS COPYING INSTALL README NEWS ChangeLog 246 AUTHORS COPYING INSTALL README NEWS ChangeLog
296 do 247 do
297 extractlist="${extractlist} ${topdir}${moduleprefix}${f}" 248 extractlist+=" ${topdir}${moduleprefix}${f}"
298 done 249 done
299 extractlist="${extractlist} $(__list_needed_subdirectories)" 250 extractlist+=" $(__list_needed_subdirectories)"
300 251
301 pushd "${WORKDIR}" > /dev/null 252 pushd "${WORKDIR}" > /dev/null
302 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2 253 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist}
303 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null 254 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} || ewarn "tar extract command failed at least partially - continuing anyway"
304 255
305 # Default $S is based on $P; rename the extracted directory to match $S if necessary 256 # Default $S is based on $P; rename the extracted directory to match $S if necessary
306 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\"" 257 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
307 258
308 popd > /dev/null 259 popd > /dev/null
333# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, 284# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
334# KMEXTRACTONLY and KMTARPARAMS. 285# KMEXTRACTONLY and KMTARPARAMS.
335kde4-meta_create_extractlists() { 286kde4-meta_create_extractlists() {
336 debug-print-function ${FUNCNAME} "$@" 287 debug-print-function ${FUNCNAME} "$@"
337 288
338 # TODO change to KMEXTRA for more strict check 289 # Add default handbook locations
339 if has doc ${IUSE//+} && use doc && [[ -n ${KMMODULE} ]]; then 290 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5.
291 if ! slot_is_at_least 4.5 ${SLOT} && has handbook ${IUSE//+} && use handbook && [[ -z ${KMNOMODULE} ]]; then
340 # We use the basename of $KMMODULE because $KMMODULE can contain 292 # We use the basename of $KMMODULE because $KMMODULE can contain
341 # the path to the module subdirectory. 293 # the path to the module subdirectory.
294 KMEXTRA_NONFATAL+="
295 doc/${KMMODULE##*/}"
296 fi
297
298 # Add default handbook locations
299 if [[ -z ${KMNOMODULE} ]] && { [[ ${KDE_HANDBOOK} = always ]] || { [[ ${KDE_HANDBOOK} = optional ]] && use handbook; }; }; then
342 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}" 300 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}"
343 fi 301 fi
344 302
345 # Add some CMake-files to KMEXTRACTONLY. 303 # Add some CMake-files to KMEXTRACTONLY.
346 # Note that this actually doesn't include KMEXTRA handling. 304 # Note that this actually doesn't include KMEXTRA handling.
347 # In those cases you should care to add the relevant files to KMEXTRACTONLY 305 # In those cases you should care to add the relevant files to KMEXTRACTONLY
348 case ${KMNAME} in 306 case ${KMNAME} in
349 kdebase) 307 kdebase)
350 KMEXTRACTONLY="${KMEXTRACTONLY} 308 KMEXTRACTONLY+="
351 apps/config-apps.h.cmake 309 apps/config-apps.h.cmake
352 apps/ConfigureChecks.cmake" 310 apps/ConfigureChecks.cmake"
353 ;; 311 ;;
354 kdebase-apps) 312 kdebase-apps)
355 KMEXTRACTONLY="${KMEXTRACTONLY} 313 KMEXTRACTONLY+="
356 config-apps.h.cmake 314 config-apps.h.cmake
357 ConfigureChecks.cmake" 315 ConfigureChecks.cmake"
358 ;; 316 ;;
359 kdebase-runtime) 317 kdebase-runtime)
360 KMEXTRACTONLY="${KMEXTRACTONLY} 318 KMEXTRACTONLY+="
361 config-runtime.h.cmake" 319 config-runtime.h.cmake"
362 ;; 320 ;;
363 kdebase-workspace) 321 kdebase-workspace)
364 KMEXTRACTONLY="${KMEXTRACTONLY} 322 KMEXTRACTONLY+="
365 config-unix.h.cmake 323 config-unix.h.cmake
366 ConfigureChecks.cmake 324 ConfigureChecks.cmake
367 config-workspace.h.cmake 325 config-workspace.h.cmake
368 config-X11.h.cmake 326 config-X11.h.cmake
369 startkde.cmake 327 startkde.cmake
370 KDE4WorkspaceConfig.cmake.in" 328 KDE4WorkspaceConfig.cmake.in"
371 ;; 329 ;;
372 kdegames) 330 kdegames)
373 if [[ ${PN} != libkdegames ]]; then 331 if [[ ${PN} != libkdegames ]]; then
374 KMEXTRACTONLY="${KMEXTRACTONLY} 332 KMEXTRACTONLY+="
375 libkdegames" 333 libkdegames/"
334 KMLOADLIBS="${KMLOADLIBS} libkdegames"
376 fi 335 fi
377 ;; 336 ;;
378 kdepim) 337 kdepim)
379 if [[ ${PN} != libkdepim ]]; then 338 if [[ ${PN} != libkdepim ]]; then
380 KMEXTRACTONLY="${KMEXTRACTONLY} 339 KMEXTRACTONLY+="
381 libkdepim" 340 libkdepim/"
382 fi 341 fi
383 case ${SLOT} in 342 KMEXTRACTONLY+="
384 4.3|live)
385 KMEXTRACTONLY="${KMEXTRACTONLY}
386 kdepim-version.h
387 config-enterprise.h.cmake" 343 config-enterprise.h.cmake
344 kleopatra/ConfigureChecks.cmake"
345 if slot_is_at_least 4.5 ${SLOT}; then
346 KMEXTRACTONLY+="
347 CTestCustom.cmake
348 kdepim-version.h.cmake"
349 else
350 KMEXTRACTONLY+="
351 kdepim-version.h"
352 fi
353 if has kontact ${IUSE//+} && use kontact; then
354 KMEXTRA+="
355 kontact/plugins/${PLUGINNAME:-${PN}}/"
356 fi
357 ;;
358 kdeutils)
359 KMEXTRACTONLY+="
360 kdeutils-version.h"
361 ;;
362 koffice)
363 KMEXTRACTONLY+="
364 filters/config-filters.h.cmake
365 "
366 case ${PV} in
367 2.0.*)
368 KMEXTRACTONLY+="
369 config-openctl.h.cmake
370 config-endian.h.cmake
371 config-openexr.h.cmake
372 config-opengl.h.cmake
373 config-prefix.h.cmake"
388 ;; 374 ;;
375 2.[12].*)
376 KMEXTRACTONLY+="
377 config-endian.h.cmake
378 config-openexr.h.cmake
379 config-opengl.h.cmake
380 config-prefix.h.cmake"
381 ;;
389 esac 382 esac
390 KMEXTRACTONLY="${KMEXTRACTONLY}
391 kleopatra/ConfigureChecks.cmake"
392 if has kontact ${IUSE//+} && use kontact; then
393 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}"
394 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/"
395 fi
396 ;;
397 koffice)
398 KMEXTRACTONLY="${KMEXTRACTONLY}
399 config-endian.h.cmake
400 filters/config-filters.h.cmake
401 config-openctl.h.cmake
402 config-openexr.h.cmake
403 config-opengl.h.cmake
404 config-prefix.h.cmake"
405 ;; 383 ;;
406 esac 384 esac
407 # Don't install cmake modules for split ebuilds, to avoid collisions. 385 # Don't install cmake modules for split ebuilds, to avoid collisions.
408 case ${KMNAME} in 386 case ${KMNAME} in
409 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics|kdepim) 387 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics)
410 case ${PN} in 388 case ${PN} in
411 libkdegames|libkdeedu|libkworkspace) 389 libkdegames|libkdeedu|libkworkspace)
412 KMEXTRA="${KMEXTRA} 390 KMEXTRA+="
413 cmake/modules/" 391 cmake/modules/"
414 ;; 392 ;;
415 *) 393 *)
416 KMCOMPILEONLY="${KMCOMPILEONLY} 394 KMCOMPILEONLY+="
417 cmake/modules/" 395 cmake/modules/"
418 ;; 396 ;;
419 esac 397 esac
420 ;; 398 ;;
421 esac 399 esac
426__list_needed_subdirectories() { 404__list_needed_subdirectories() {
427 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist 405 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
428 406
429 # We expand KMEXTRA by adding CMakeLists.txt files 407 # We expand KMEXTRA by adding CMakeLists.txt files
430 kmextra="${KMEXTRA}" 408 kmextra="${KMEXTRA}"
431 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}" 409 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
432 for i in ${kmextra}; do 410 for i in ${kmextra}; do
433 kmextra_expanded="${kmextra_expanded} ${i}" 411 kmextra_expanded+=" ${i}"
434 j=$(dirname ${i}) 412 j=$(dirname ${i})
435 while [[ ${j} != "." ]]; do 413 while [[ ${j} != "." ]]; do
436 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 414 kmextra_expanded+=" ${j}/CMakeLists.txt";
437 j=$(dirname ${j}) 415 j=$(dirname ${j})
438 done 416 done
439 done 417 done
440 418
441 # Expand KMMODULE 419 # Expand KMMODULE
442 if [[ -n ${KMMODULE} ]]; then 420 if [[ -n ${KMMODULE} ]]; then
443 kmmodule_expanded="${KMMODULE}" 421 kmmodule_expanded="${KMMODULE}"
444 j=$(dirname ${KMMODULE}) 422 j=$(dirname ${KMMODULE})
445 while [[ ${j} != "." ]]; do 423 while [[ ${j} != "." ]]; do
446 kmmodule_expanded="${kmmodule_expanded} ${j}/CMakeLists.txt"; 424 kmmodule_expanded+=" ${j}/CMakeLists.txt";
447 j=$(dirname ${j}) 425 j=$(dirname ${j})
448 done 426 done
449 fi 427 fi
450 428
451 # Expand KMCOMPILEONLY 429 # Expand KMCOMPILEONLY
452 for i in ${KMCOMPILEONLY}; do 430 for i in ${KMCOMPILEONLY}; do
453 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 431 kmcompileonly_expanded+=" ${i}"
454 j=$(dirname ${i}) 432 j=$(dirname ${i})
455 while [[ ${j} != "." ]]; do 433 while [[ ${j} != "." ]]; do
456 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 434 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
457 j=$(dirname ${j}) 435 j=$(dirname ${j})
458 done 436 done
459 done 437 done
460 438
461 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 439 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
465 # Create final list of stuff to extract 443 # Create final list of stuff to extract
466 # We append topdir only when specified (usually for tarballs) 444 # We append topdir only when specified (usually for tarballs)
467 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 445 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
468 ${KMEXTRACTONLY} 446 ${KMEXTRACTONLY}
469 do 447 do
470 extractlist="${extractlist} ${topdir}${moduleprefix}${i}" 448 extractlist+=" ${topdir}${moduleprefix}${i}"
471 done 449 done
472 450
473 echo ${extractlist} 451 echo ${extractlist}
474} 452}
475 453
499 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 477 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
500 fi 478 fi
501 done 479 done
502} 480}
503 481
504# FIXME: add description
505# @FUNCTION: kde4-meta_change_cmakelists 482# @FUNCTION: kde4-meta_change_cmakelists
506# @DESCRIPTION: 483# @DESCRIPTION:
484# Adjust CMakeLists.txt to comply to our splitting.
507kde4-meta_change_cmakelists() { 485kde4-meta_change_cmakelists() {
508 debug-print-function ${FUNCNAME} "$@" 486 debug-print-function ${FUNCNAME} "$@"
509 487
510 pushd "${S}" > /dev/null 488 pushd "${S}" > /dev/null
511 489
512 comment_all_add_subdirectory ./ 490 comment_all_add_subdirectory ./
513 491
514 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 492 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
515 if [[ -f "${S}"/CMakeLists.txt ]]; then 493 if [[ -f CMakeLists.txt ]]; then
516 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 494 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
517 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 495 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
518 -i "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 496 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
519 fi 497 fi
520 498
521 if [[ -z ${KMNOMODULE} ]]; then 499 if [[ -z ${KMNOMODULE} ]]; then
522 # Restore "add_subdirectory" in $KMMODULE subdirectories 500 # Restore "add_subdirectory" in $KMMODULE subdirectories
523 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 501 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
502 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
524 die "${LINENO}: died in KMMODULE section" 503 die "${LINENO}: died in KMMODULE section"
525 _change_cmakelists_parent_dirs ${KMMODULE} 504 _change_cmakelists_parent_dirs ${KMMODULE}
526 fi 505 fi
527 506
528 local i 507 local i
529 508
530 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY 509 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
531 for i in ${KMEXTRACTONLY}; do 510 for i in ${KMEXTRACTONLY}; do
532 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then 511 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
533 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \ 512 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
513 -i ${i}/../CMakeLists.txt || \
534 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}" 514 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
535 fi 515 fi
536 done 516 done
537 517
538 # KMCOMPILEONLY 518 # KMCOMPILEONLY
560 # KMEXTRA_NONFATAL section 540 # KMEXTRA_NONFATAL section
561 for i in ${KMEXTRA_NONFATAL}; do 541 for i in ${KMEXTRA_NONFATAL}; do
562 if [[ -d "${S}"/${i} ]]; then 542 if [[ -d "${S}"/${i} ]]; then
563 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 543 find "${S}"/${i} -name CMakeLists.txt -print0 | \
564 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 544 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
565 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 545 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
566 _change_cmakelists_parent_dirs ${i} 546 _change_cmakelists_parent_dirs ${i}
567 fi 547 fi
568 done 548 done
569 549
570 case ${KMNAME} in 550 case ${KMNAME} in
571 kdebase-workspace) 551 kdebase-workspace)
572 # COLLISION PROTECT section 552 # COLLISION PROTECT section
573 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 553 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
574 # not as a part of every package. 554 # not as a part of every package.
575 if [[ ${PN} != kdebase-startkde && -f "${S}"/CMakeLists.txt ]]; then 555 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
576 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 556 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
577 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 557 sed -e '/startkde/s/^/#DONOTINSTALL /' \
578 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 558 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
579 fi 559 fi
580 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 560 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
581 if [[ ${PN} != libkworkspace ]]; then 561 if [[ ${PN} != libkworkspace ]]; then
582 sed -i -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 562 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
583 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip EXPORT section" 563 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section"
584 fi 564 fi
585 ;; 565 ;;
586 kdebase-runtime) 566 kdebase-runtime)
587 # COLLISION PROTECT section 567 # COLLISION PROTECT section
588 # Only install the kde4 script as part of kde-base/kdebase-data 568 # Only install the kde4 script as part of kde-base/kdebase-data
589 if [[ ${PN} != kdebase-data && -f "${S}"/CMakeLists.txt ]]; then 569 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
590 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 570 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
591 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 571 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
592 fi 572 fi
593 ;;
594 kdepim)
595 case ${PN} in
596 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn)
597 sed -i -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
598 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed"
599 _change_cmakelists_parent_dirs kmail
600 ;; 573 ;;
601 esac 574 kdenetwork)
602 ;;
603 kdewebdev)
604 # Disable hardcoded kdepimlibs check 575 # Disable hardcoded kdepimlibs check
605 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \ 576 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
606 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2 REQUIRED)/' \
607 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt REQUIRED)/' \
608 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost REQUIRED)/' \
609 -i CMakeLists.txt || die "failed to disable hardcoded checks" 577 -i CMakeLists.txt || die "failed to disable hardcoded checks"
610 ;; 578 ;;
579 kdepim)
580 # Disable hardcoded checks
581 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
582 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
583 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
584 -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
585 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
586 -i CMakeLists.txt || die "failed to disable hardcoded checks"
587 # Disable broken or redundant build logic
588 if ( has kontact ${IUSE//+} && use kontact ) || [[ ${PN} = kontact ]]; then
589 sed -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
590 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
591 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
592 fi
593 if ! slot_is_at_least 4.5 ${SLOT}; then
594 case ${PN} in
595 kalarm|kmailcvt|kontact|korganizer|korn)
596 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
597 -e '/add_custom_target(kmail_xml /,/)/p' \
598 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
599 _change_cmakelists_parent_dirs kmail
600 ;;
601 esac
602 fi
603 ;;
604 kdewebdev)
605 # Disable hardcoded checks
606 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
607 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
608 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
609 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
610 -i CMakeLists.txt || die "failed to disable hardcoded checks"
611 ;;
611 koffice) 612 koffice)
612 # prevent collisions 613 # Prevent collisions
613 if [[ ${PN} != koffice-data ]]; then 614 if [[ ${PN} != koffice-data ]]; then
614 sed -i -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \ 615 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
615 "${S}"/cmake/modules/CMakeLists.txt || \ 616 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
617 sed -e '/install(.\+config-openexr\.h.\+)/d' \
616 die "${LINENO}: sed died in collision prevention section" 618 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
619 fi
620 # koffice 2.0
621 case ${PV} in
622 2.0.[1-9])
617 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \ 623 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
618 "${S}"/CMakeLists.txt || \ 624 "${S}"/CMakeLists.txt || \
619 die "${LINENO}: sed died in collision prevention section" 625 die "${LINENO}: sed died in collision prevention section"
626 ;;
627 *) ;;
628 esac
629 # koffice 2.1.[8-9][0-9] and 9999
630 case ${PV} in
631 2.1.8[0-9]|2.1.9[0-9]|9999)
632 sed -e '/^option(BUILD/s/ON/OFF/' \
633 -e '/^if(NOT BUILD_kchart/,/^endif(NOT BUILD_kchart/d' \
634 -e '/^if(BUILD_koreport/,/^endif(BUILD_koreport/d' \
635 -e 's/set(SHOULD_BUILD_F_OFFICE TRUE)/set(SHOULD_BUILD_F_OFFICE FALSE)/' \
636 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
637 if [[ ${PN} != koffice-data ]] && [[ ${PV} == 9999 ]]; then
638 sed -e '/config-opengl.h/d' \
639 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
640
620 fi 641 fi
642 ;;
643 *) ;;
644 esac
621 esac 645 esac
622 646
623 popd > /dev/null 647 popd > /dev/null
624} 648}
625 649
628# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 652# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
629# ebuilds. 653# ebuilds.
630kde4-meta_src_configure() { 654kde4-meta_src_configure() {
631 debug-print-function ${FUNCNAME} "$@" 655 debug-print-function ${FUNCNAME} "$@"
632 656
657 # backwards-compatibility: make mycmakeargs an array, if it isn't already
658 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
659 mycmakeargs=(${mycmakeargs})
660 fi
661
633 # Set some cmake default values here (usually workarounds for automagic deps) 662 # Set some cmake default values here (usually workarounds for automagic deps)
634 case ${KMNAME} in 663 case ${KMNAME} in
635 kdewebdev) 664 kdewebdev)
636 mycmakeargs=" 665 mycmakeargs=(
637 -DWITH_KdepimLibs=OFF 666 -DWITH_KdepimLibs=OFF
638 -DWITH_LibXml2=OFF 667 -DWITH_LibXml2=OFF
639 -DWITH_LibXslt=OFF 668 -DWITH_LibXslt=OFF
640 -DWITH_Boost=OFF 669 -DWITH_Boost=OFF
641 -DWITH_LibTidy=OFF 670 -DWITH_LibTidy=OFF
642 ${mycmakeargs}" 671 "${mycmakeargs[@]}"
672 )
673 ;;
674 koffice)
675 case ${PV} in
676 2.1.8[0-9]|2.1.9[0-9]|9999)
677 if [[ ${PN} != "kchart" ]]; then
678 mycmakeargs=(
679 -DBUILD_koreport=OFF
680 "${mycmakeargs[@]}"
681 )
682 fi
683 ;;
684 esac
643 ;; 685 ;;
644 esac 686 esac
645 687
646 kde4-base_src_configure 688 kde4-base_src_configure
647} 689}
651# General function for compiling split KDE4 applications. 693# General function for compiling split KDE4 applications.
652# Overrides kde4-base_src_compile. 694# Overrides kde4-base_src_compile.
653kde4-meta_src_compile() { 695kde4-meta_src_compile() {
654 debug-print-function ${FUNCNAME} "$@" 696 debug-print-function ${FUNCNAME} "$@"
655 697
656 kde4-base_src_compile 698 kde4-base_src_compile "$@"
657} 699}
658 700
659# @FUNCTION: kde4-meta_src_test 701# @FUNCTION: kde4-meta_src_test
660# @DESCRIPTION: 702# @DESCRIPTION:
661# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 703# Currently just calls its equivalent in kde4-base.eclass(5) if
662# ebuilds. 704# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
663kde4-meta_src_test() { 705kde4-meta_src_test() {
664 debug-print-function $FUNCNAME "$@" 706 debug-print-function $FUNCNAME "$@"
665 707
708 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
666 kde4-base_src_test 709 kde4-base_src_test
710 else
711 einfo "Tests disabled"
712 fi
667} 713}
668 714
669# @FUNCTION: kde4-meta_src_install 715# @FUNCTION: kde4-meta_src_install
670# @DESCRIPTION: 716# @DESCRIPTION:
671# Function for installing KDE4 split applications. 717# Function for installing KDE4 split applications.
672kde4-meta_src_install() { 718kde4-meta_src_install() {
673 debug-print-function $FUNCNAME "$@" 719 debug-print-function $FUNCNAME "$@"
674 720
721 # Search ${S}/${KMMODULE} and install common documentation files found
722 local doc
723 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
724 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
725 done
726
675 kde4-base_src_install 727 kde4-base_src_install
676} 728}
677 729
678# @FUNCTION: kde4-meta_src_make_doc
679# @DESCRIPTION:
680# This function searches in ${S}/${KMMODULE},
681# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist.
682kde4-meta_src_make_doc() {
683 debug-print-function ${FUNCNAME} "$@"
684
685 local doc
686 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
687 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}"
688 done
689
690 kde4-base_src_make_doc
691}
692
693# @FUNCTION: kde4-meta_pkg_postinst 730# @FUNCTION: kde4-meta_pkg_postinst
694# @DESCRIPTION: 731# @DESCRIPTION:
695# Display information about application handbook and invoke kbuildsycoca4. 732# Invoke kbuildsycoca4.
696kde4-meta_pkg_postinst() { 733kde4-meta_pkg_postinst() {
697 debug-print-function ${FUNCNAME} "$@" 734 debug-print-function ${FUNCNAME} "$@"
698
699 if has doc ${IUSE//+} && ! use doc; then
700 echo
701 einfo "Application handbook for ${PN} has not been installed."
702 einfo "To install handbook, reemerge =${CATEGORY}/${P} with 'doc' USE flag."
703 echo
704 fi
705 735
706 kde4-base_pkg_postinst 736 kde4-base_pkg_postinst
707} 737}
708 738
709# @FUNCTION: kde4-meta_pkg_postrm 739# @FUNCTION: kde4-meta_pkg_postrm

Legend:
Removed from v.1.18  
changed lines
  Added in v.1.46

  ViewVC Help
Powered by ViewVC 1.1.20